#!/usr/bin/env python
# encoding: utf-8
#
# $Id$
# $URL$

"""
checks.py

Created by Marcus Stoegbauer on 2013-01-10.
Copyright (c) 2013 __MyCompanyName__. All rights reserved.
"""

import sys
import os
import platform

class checks(object):
  def __init__(self):
    pass
  # def __init__
  
  def getShortHostname(self):
    """docstring for getShortHostname"""
    hostname = platform.node()
    if hostname.count("."):
      hostname = hostname.split(".")[0]
    return hostname
  # def getShortHostname
    
  def __classesForHost__(self):
    """docstring for __classesForHost"""
    classes = []
    for c in dir(self):
      if c.startswith("__"): 
        continue
      # if __
      ret = getattr(self, c)()
      if len(ret) == 3:
        classes.append(ret)
    # for c
    return map(lambda k: (k[1],k[2]), sorted(classes, key=lambda k: k[0]))
  # def __classesForHost__
  
  def header(self):
    """docstring for header"""
    return (0, "", "header")
  # def header
  
  def footer(self):
    """docstring for footer"""
    return (1000, "", "footer")
  
  def all(self):
    """docstring for all"""
    return (998, "", "all")
  # def all
  
  def arch(self):
    """docstring for arch"""
    return(800, "Arch", platform.system())
  # def arch
  
  def hostname(self):
    """docstring for hostname"""
    hostname = self.getShortHostname()
    return(10, "Host", hostname)
  # def hostname

  def app(self):
    """docstring for app"""
    hostname = self.getShortHostname()
    if (hostname == "glitters"):
      return(500, "", "rancid_hosts")
    else:
     return ()
  # def app
# def checks